/* ICONS: https://www.iconfinder.com/search?q=&iconset=google-material-design-icons */

* {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
}

:root {
    --background-color: #edf1f5;
    --font-size-normal: 16px;
    --padding-normal: var(--font-size-normal);
    --padding-small: calc(var(--font-size-normal) / 2);
    --margin-normal: var(--font-size-normal);
    --margin-small: calc(var(--font-size-normal) / 2);
    --margin-big: calc(var(--font-size-normal) * 2);
    --link-color: #2f4cf5;
    --border-color: #dfe6ee;
}

html {
    background-color: var(--background-color);
    font-size: var(--font-size-normal);
    font-family: system-ui, -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
}

a {
    color: var(--link-color);
}

h1 {
    margin-bottom: var(--margin-normal);
}

p {
    margin-bottom: var(--margin-normal);
}

img {
    max-width: 100%;
    height: auto;
}

ol {
    margin-bottom: var(--margin-normal);
    line-height: 1.5;
}

ol li::marker {
    font-weight: bold;
}

label {
    display: block;
    margin-bottom: var(--margin-small);
}

input {
    padding: var(--padding-small);
    border-radius: 4px;
    border: 1px solid var(--border-color);
    width: 100%;
    font-weight: bold;
}

input[type="checkbox"] {
    width: 16px;
    height: 16px;
}

input::-ms-reveal,
input::-ms-clear {
    display: none;
}

select {
    padding: var(--padding-small);
    border-radius: 4px;
    border: 1px solid var(--border-color);
    width: 100%;
}

input:focus {
    outline: 0 none;
    border: 1px solid var(--border-color);
}

.button-submit {
    background-color: var(--link-color);
    color: white;
    height: 48px;
    border: none;
    transition: background-color 0.2s ease-in-out;
}

.button-submit:hover {
    background-color: #1832c7;
    cursor: pointer;
}

h1 {
    position: relative;
    margin-bottom: var(--margin-big);
}

h1:before {
    position: absolute;
    bottom: -4px;
    content: "";
    height: 3px;
    width: 70px;
    background-color: #2f4cf5;
}

.welcome-text {
    font-weight: bold;
    font-size: 18px;
    margin-bottom: var(--margin-small);
}

.form-page {
    min-height: 100vh;
    display: flex;
    align-items: center;
    justify-content: center;
}

.form-card {
    background-color: white;
    padding: var(--padding-normal);
    border-radius: 16px;
    border: 1px solid var(--border-color);
    width: 320px;
}

.form-input-container {
    margin-bottom: var(--margin-normal);
}

.sign-form {
    margin: var(--margin-big) 0;
}

.form-info-text {
    font-size: 12px;
    color: #969696;
    text-align: center;
}

.error-list {
    background-color: #fccccc;
    border: 1px solid #cf8888;
    padding: 16px;
    padding-left: 32px;
    border-radius: 4px;
    display: none;
}

.diplay-error-list {
    display: block;
}

.error-list li {
    margin-bottom: 8px;
}

.success-message {
    line-height: 1.5;
    background-color: #d0fccc;
    border: 1px solid #88cf9a;
    padding: var(--padding-normal);
    border-radius: 4px;
    display: none;
}

.display-success-message {
    display: block;
}

.hide-form {
    display: none;
}

/**********************/
/*** PASSWORD INPUT ***/
/**********************/

.input-password-container {
    padding: var(--padding-small);
    border-radius: 4px;
    border: 1px solid var(--border-color);
    display: flex;
    justify-content: space-between;
    gap: 4px;
}

.password-visibility-button {
    background-color: transparent;
    border: none;

    &:hover {
       cursor: pointer;
    }
}

.password-visibility-icon {
    width: 20px;
    display: block;
}

#password {
    margin: 0;
    padding: 0;
    border: none;
}

/*****************/
/*** TODO PAGE ***/
/*****************/

.todo-page-content {
    display: flex;
    min-height: 100vh;
}

.todo-page-header {
    background-color: white;
    display: none;
}


/****************************/
/*** TODO PAGE SIDE PANEL ***/
/****************************/

.side-panel {
    flex: 1 1 20%;
    padding: var(--padding-normal);
}

.profile {
    padding: 6px;
    margin-left: -6px;
    margin-bottom: 16px;
    border-radius: 4px;
    display: flex;
    justify-content: space-between;
    transition: background-color 0.2s ease-in-out;
}

.profile:hover {
    background-color: #e2e7ec;
}

.user-name {
    font-weight: 600;
    margin: 0;
}

.profile:hover > .logout-button {
    opacity: 1;
}

.logout-button {
    background-color: transparent;
    border: none;
    cursor: pointer;
    opacity: 0;
    transition: opacity 0.2s ease-in-out;
}

.logout-icon {
    width: 20px;
    display: block;
}

.lists-heading {
    display: flex;
    justify-content: space-between;
}

.lists-title {
    font-weight: bold;
    margin: 0;
    padding-block: 6px;
}

.lists-heading:hover > .add-list-button{
    opacity: 1;
}

.add-list-button {
    background-color: transparent;
    border: none;
    padding-inline: 6px;
    margin-right: -6px;
    opacity: 0;
    transition: background-color 0.2s ease-in-out;
    transition: opacity 0.2s ease-in-out;
}

.add-list-button:hover {
    background-color: #e2e7ec;
    border-radius: 4px;
    cursor: pointer;
}

.add-list-icon {
    width: 20px;
    display: block;
}

.list-item {
    list-style: none;
    display: flex;
    justify-content: space-between;
    align-items: center;
    min-height: 32px;
    padding: 6px;
    margin: 0 -6px;
    transition: background-color 0.2s ease-in-out;
}

.list-item:hover {
    background-color: #e2e7ec;
    border-radius: 4px;
    cursor: pointer;
}

.list-name {
    margin: 0;
}

.list-item:hover > .list-options-button {
    opacity: 1;
}

.list-options-button {
    background-color: transparent;
    border: none;
    cursor: pointer;
    opacity: 0;
    transition: opacity 0.2s ease-in-out;
    position: relative;
}

.list-options-icon {
    width: 20px;
    display: block;
}

.list-options-button:hover > .list-options-menu {
    display: block;
}

.list-options-menu {
    position: absolute;
    z-index: 99;
    right: 50%;
    transform: translateX(50%);
    background-color: white;
    border: 1px solid var(--border-color);
    border-radius: 4px;
    display: none;
}

.list-options-menu-button {
    display: flex;
    align-items: center;
    gap: 16px;
    cursor: pointer;
    border-bottom: 1px solid var(--border-color);
    background-color: transparent;
    border: none;
    width: 100%;
    padding: 8px;
}

.list-options-menu-button:hover {
    background-color: #e2e7ec;
}

.list-options-menu-button:last-child {
    border-bottom: none;
}

.list-delete-button {
    color: #e02f22;
}

.list-delete-button > .list-options-icon {
    filter: brightness(0) saturate(100%) invert(33%) sepia(80%) saturate(2438%) hue-rotate(341deg) brightness(84%) contrast(111%);
}

.list-options-menu-label {
    margin: 0;
}

/***********************/
/*** TODO PAGE TODOS ***/
/***********************/

.todos-container {
    flex: 1 1 80%;
    background-color: white;
}

.todo-center,
.no-todo {
    width: 70%;
    margin-inline: auto;
    padding: var(--padding-normal);
}

.selected-list-name,
.no-todo-title {
    font-size: 24px;
    font-weight: bold;
}

.selected-list-name {
    margin: 0;
}

.no-todo {
    min-height: 100vh;
    display: flex;
    align-items: center;
}

.no-to-illustation {
    display: block;
    margin-inline: auto;
}

.todo-list {
    margin: 0;
    padding: 0;
    list-style: none;
}

.todo-body {
    display: flex;
    gap: 8px;
    align-items: center;
    padding-block: 12px;
    border-bottom: 1px solid var(--border-color);
}

.todo-body:has(.todo-checkbox:checked) .todo-content,
.todo-body:has(.todo-checkbox:checked) .todo-due-date {
    color: #969696;
    text-decoration: line-through;
}

.todo-checkbox {
    width: 16px;
    height: 16px;
}

.todo-content {
    margin: 0;
}

.todo-options-button {
    background-color: transparent;
    border: none;
    cursor: pointer;
    padding: 6px;
    opacity: 0;
    position: relative;
    transition: opacity 0.2s ease-in-out;
    transition: background-color 0.2s ease-in-out;
}

.todo-options-button:hover {
    background-color: #e2e7ec;
    border-radius: 4px;
}

.todo-body:hover > .todo-options-button {
    opacity: 1;
}

.todo-options-icon {
    width: 20px;
    display: block;
}

.todo-content-container {
    flex: 1 1 100%;
}

.todo-row {
    display: flex;
    gap: 8px;
    align-items: center;
}

.todo-due-date {
    color: #616161;
    margin: 0;
    margin-top: 4px;
    padding-left: 24px;
}

.todo-due-date-late {
    color: #e02f22;
}

.modal-add-todo {
    border: 1px solid var(--border-color);
    border-top: none;
    border-radius: 0 0 4px 4px;
    display: none;
}

.modal-add-todo:first-child {
    border: 1px solid var(--border-color) !important;
}

.modal-add-todo-show {
    display: block;
}

.add-todo-button {
    background-color: transparent;
    border: none;
    font-size: 16px;
    color: #757575;
    display: flex;
    justify-content: center;
    gap: 8px;
    align-items: center;
    width: 100%;
    padding-block: var(--margin-normal);
}

.add-todo-button-hide {
    display: none;
}

.add-todo-button:hover {
    color: #424242;
    cursor: pointer;
}

.add-todo-button p {
    margin: 0;
}

.add-todo-button:hover .add-todo-icon {
    filter: invert(20%) sepia(0%) saturate(1815%) hue-rotate(149deg) brightness(98%) contrast(79%);
}

.add-todo-icon {
    filter: invert(55%) sepia(0%) saturate(173%) hue-rotate(146deg) brightness(82%) contrast(84%);
    width: 20px;
    display: block;
}

.todo-options-menu {
    width: 100px;
    height: 100px;
    background-color: red;
    position: absolute;
    z-index: 99;
    left: 50%;
    transform: translateX(-50%);
}

.modal-edit-todo {
    border: 1px solid var(--border-color);
    border-top: none;
}

.modal-edit-todo:first-child {
    border: 1px solid var(--border-color) !important;
    border-top: none;
}

.hide {
    display: none;
}

.show {
    display: block;
}

/*********************/
/*** DRAG AND DROP ***/
/*********************/
.todo-item {
    background-color: white;
}

.draggable {
    cursor: move;
}

.dragging {
    opacity: 0.3;
    background-color: var(--border-color);
    padding-inline: 16px;
    margin-inline: -16px;
    border-radius: 4px;
}


/************************/
/*** TODO PAGE MODALS ***/
/************************/

.modal-overlay {
    top: 50%;
    left: 50%;
    translate: -50% -50%;
    border: 1px solid var(--border-color);
    width: 25%;
    border-radius: 4px;
}

.modal-overlay::backdrop {
    background-color: rgba(0, 0, 0, 0.7);
}

.modal-header {
    padding: var(--padding-normal);
    font-weight: bold;
}

.modal-title {
    margin: 0;
    font-size: 18px;
}

.modal-divider {
    margin: 0;
    padding: 0;
    border: 1px solid var(--border-color);
}

.modal-form-input {
    padding: var(--padding-normal);
}

.modal-form-input-flex {
    display: flex;
    align-items: center;
    gap: 16px;
}

.modal-form-input-flex > input {
    width: initial;
}

.modal-form-buttons-container {
    display: flex;
    justify-content: end;
    gap: 16px;
}

.modal-button {
    padding: 12px;
    cursor: pointer;
    border: 0;
    border-radius: 4px;
}

.modal-button-cancel {
    background-color: #e7e7e7;
    transition: background-color 0.2s ease-in-out;
}

.modal-button-cancel:hover {
    background-color: #dadada;
}

.modal-button-confirm {
    background-color: #2f4cf5;
    color: white;
    transition: background-color 0.2s ease-in-out;
}

.modal-button-confirm:hover {
    background-color: #1832c7;
}

.modal-delete-list-overlay {
    width: 50ch;
}

.modal-delete-text {
    padding-inline: var(--padding-normal);
    margin-block: var(--margin-normal);
}

/**************************/
/*** HIDE TODO CHECKBOX ***/
/**************************/

.todo-center-header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 24px;
}

.hide-done-todo-container {
    display: flex;
    align-items: center;
    gap: 8px;
    margin: 0;
}

#hide-done-todo {
    width: initial;
    margin-top: 4px;
}

/******************/
/*** RESPONSIVE ***/
/******************/

@media screen and (max-width: 720px) {
    .todo-page-header {
        display: flex;
        justify-content: end;
    }

    .menu-open,
    .menu-close {
        border: none;
        background-color: transparent;
        padding: 16px;
    }

    .menu-open img,
    .menu-close img {
        display: block;
        width: 32px;
    }

    .side-panel {
        display: table;
        position: absolute;
        min-height: 100vh;
        top: 0;
        left: 0;
        right: 50%;
        background-color: var(--background-color);
        z-index: 99;
        transform: translateX(-100%);
        transition: transform 0.2s ease-out;
    }

    .side-panel-open {
        transform: translateX(0);
    }

    .todo-center {
        width: 100%;
        padding-inline: 16px;
    }

    .todo-center-header {
        flex-direction: column;
        gap: 16px;
        align-items: start;
    }

    .hide-done-todo-container {
        align-self: flex-end;
    }

    .logout-button,
    .list-options-button,
    .todo-options-button,
    .todo-options-button,
    .add-list-button {
        opacity: 1;
    }

    .logout-button,
    .list-options-button,
    .add-list-button {
        margin-left: 16px;
    }

    .list-options-button {
        padding: 4px;
    }

    .list-options-menu {
        top: calc(100% + 4px)
    }

    .modal-overlay {
        width: 100%;
        padding: 16px;
    }
}